Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/DICOM.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/DICOM.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/DICOM.pm	(revision 34921)
@@ -21,5 +21,5 @@
 use Image::ExifTool qw(:DataAccess :Utils);
 
-$VERSION = '1.11';
+$VERSION = '1.22';
 
 # DICOM VR (Value Representation) format conversions
@@ -50,5 +50,5 @@
 %Image::ExifTool::DICOM::Main = (
     GROUPS => { 2 => 'Image' },
-    PROCESS_PROC => 0,  # set this to zero to omit tags from lookup (way too many!)
+    VARS => { NO_LOOKUP => 1 }, # omit tags from lookup (way too many!)
     NOTES => q{
         The DICOM format is based on the ACR-NEMA specification, but adds a file
@@ -58,4 +58,7 @@
         L<http://medical.nema.org/>).  The table below contains tags from the DICOM
         2009 and earlier specifications plus some vendor-specific private tags.
+
+        Note that DICOM information may be saved in other file formats using the
+        L<XMP DICOM Tags|Image::ExifTool::TagNames/XMP DICOM Tags>.
     },
     # file meta information group (names end with VR)
@@ -2341,5 +2344,5 @@
     '0072,0514' => { VR => 'FD', Name => 'ReformattingInterval' },
     '0072,0516' => { VR => 'CS', Name => 'ReformattingOpInitialViewDir' },
-    '0072,0520' => { VR => 'CS', Name => '3DRenderingType' },
+    '0072,0520' => { VR => 'CS', Name => 'RenderingType3D' },
     '0072,0600' => { VR => 'SQ', Name => 'SortingOperationsSequence' },
     '0072,0602' => { VR => 'CS', Name => 'SortByCategory' },
@@ -3405,4 +3408,7 @@
     '1.2.840.10008.5.1.4.1.1.13.1.1' => 'X-Ray 3D Angiographic Image Storage',
     '1.2.840.10008.5.1.4.1.1.13.1.2' => 'X-Ray 3D Craniofacial Image Storage',
+    '1.2.840.10008.5.1.4.1.1.13.1.3' => 'Breast Tomosynthesis Image Storage',
+    '1.2.840.10008.5.1.4.1.1.14.1' => 'Intravascular Optical Coherence Tomography Image Storage - For Presentation',
+    '1.2.840.10008.5.1.4.1.1.14.2' => 'Intravascular Optical Coherence Tomography Image Storage - For Processing',
     '1.2.840.10008.5.1.4.1.1.20' => 'Nuclear Medicine Image Storage',
     '1.2.840.10008.5.1.4.1.1.66' => 'Raw Data Storage',
@@ -3425,4 +3431,15 @@
     '1.2.840.10008.5.1.4.1.1.77.1.5.3' => 'Stereometric Relationship Storage',
     '1.2.840.10008.5.1.4.1.1.77.1.5.4' => 'Ophthalmic Tomography Image Storage',
+    '1.2.840.10008.5.1.4.1.1.77.1.6' => 'VL Whole Slide Microscopy Image Storage',
+    '1.2.840.10008.5.1.4.1.1.78.1' => 'Lensometry Measurements Storage',
+    '1.2.840.10008.5.1.4.1.1.78.2' => 'Autorefraction Measurements Storage',
+    '1.2.840.10008.5.1.4.1.1.78.3' => 'Keratometry Measurements Storage',
+    '1.2.840.10008.5.1.4.1.1.78.4' => 'Subjective Refraction Measurements Storage',
+    '1.2.840.10008.5.1.4.1.1.78.5' => 'Visual Acuity Measurements Storage',
+    '1.2.840.10008.5.1.4.1.1.78.6' => 'Spectacle Prescription Report Storage',
+    '1.2.840.10008.5.1.4.1.1.78.7' => 'Ophthalmic Axial Measurements Storage',
+    '1.2.840.10008.5.1.4.1.1.78.8' => 'Intraocular Lens Calculations Storage',
+    '1.2.840.10008.5.1.4.1.1.79.1' => 'Macular Grid Thickness and Volume Report Storage SOP Class',
+    '1.2.840.10008.5.1.4.1.1.80.1' => 'Ophthalmic Visual Field Static Perimetry Measurements Storage',
     '1.2.840.10008.5.1.4.1.1.88.1' => 'Text SR Storage - Trial (Retired)',
     '1.2.840.10008.5.1.4.1.1.88.2' => 'Audio SR Storage - Trial (Retired)',
@@ -3437,4 +3454,6 @@
     '1.2.840.10008.5.1.4.1.1.88.65' => 'Chest CAD SR',
     '1.2.840.10008.5.1.4.1.1.88.67' => 'X-Ray Radiation Dose SR Storage',
+    '1.2.840.10008.5.1.4.1.1.88.69' => 'Colon CAD SR',
+    '1.2.840.10008.5.1.4.1.1.88.70' => 'Implantation Plan SR Document Storage',
     '1.2.840.10008.5.1.4.1.1.104.1' => 'Encapsulated PDF Storage',
     '1.2.840.10008.5.1.4.1.1.104.2' => 'Encapsulated CDA Storage',
@@ -3474,4 +3493,11 @@
     '1.2.840.10008.5.1.4.34.4.4' => 'Unified Procedure Step - Event SOP Class',
     '1.2.840.10008.5.1.4.34.5' => 'Unified Worklist and Procedure Step SOP Instance',
+    '1.2.840.10008.5.1.4.34.6.1' => 'Unified Procedure Step - Push SOP Class',
+    '1.2.840.10008.5.1.4.34.6.2' => 'Unified Procedure Step - Watch SOP Class',
+    '1.2.840.10008.5.1.4.34.6.3' => 'Unified Procedure Step - Pull SOP Class',
+    '1.2.840.10008.5.1.4.34.6.4' => 'Unified Procedure Step - Event SOP Class',
+    '1.2.840.10008.5.1.4.34.7' => 'RT Beams Delivery Instruction Storage',
+    '1.2.840.10008.5.1.4.34.8' => 'RT Conventional Machine Verification',
+    '1.2.840.10008.5.1.4.34.9' => 'RT Ion Machine Verification',
     '1.2.840.10008.5.1.4.37.1' => 'General Relevant Patient Information Query',
     '1.2.840.10008.5.1.4.37.2' => 'Breast Imaging Relevant Patient Information Query',
@@ -3480,6 +3506,22 @@
     '1.2.840.10008.5.1.4.38.2' => 'Hanging Protocol Information Model - FIND',
     '1.2.840.10008.5.1.4.38.3' => 'Hanging Protocol Information Model - MOVE',
+    '1.2.840.10008.5.1.4.39.1' => 'Color Palette Storage',
+    '1.2.840.10008.5.1.4.39.2' => 'Color Palette Information Model - FIND',
+    '1.2.840.10008.5.1.4.39.3' => 'Color Palette Information Model - MOVE',
+    '1.2.840.10008.5.1.4.39.4' => 'Color Palette Information Model - GET',
     '1.2.840.10008.5.1.4.41' => 'Product Characteristics Query SOP Class',
     '1.2.840.10008.5.1.4.42' => 'Substance Approval Query SOP Class',
+    '1.2.840.10008.5.1.4.43.1' => 'Generic Implant Template Storage',
+    '1.2.840.10008.5.1.4.43.2' => 'Generic Implant Template Information Model - FIND',
+    '1.2.840.10008.5.1.4.43.3' => 'Generic Implant Template Information Model - MOVE',
+    '1.2.840.10008.5.1.4.43.4' => 'Generic Implant Template Information Model - GET',
+    '1.2.840.10008.5.1.4.44.1' => 'Implant Assembly Template Storage',
+    '1.2.840.10008.5.1.4.44.2' => 'Implant Assembly Template Information Model - FIND',
+    '1.2.840.10008.5.1.4.44.3' => 'Implant Assembly Template Information Model - MOVE',
+    '1.2.840.10008.5.1.4.44.4' => 'Implant Assembly Template Information Model - GET',
+    '1.2.840.10008.5.1.4.45.1' => 'Implant Template Group Storage',
+    '1.2.840.10008.5.1.4.45.2' => 'Implant Template Group Information Model - FIND',
+    '1.2.840.10008.5.1.4.45.3' => 'Implant Template Group Information Model - MOVE',
+    '1.2.840.10008.5.1.4.45.4' => 'Implant Template Group Information Model - GET',
     '1.2.840.10008.15.0.3.1' => 'dicomDeviceName',
     '1.2.840.10008.15.0.3.2' => 'dicomDescription',
@@ -3527,10 +3569,10 @@
 # Inputs: 0) ExifTool object reference, 1) DirInfo reference
 # Returns: 1 on success, 0 if this wasn't a valid DICOM file
-sub ProcessDICM($$)
+sub ProcessDICOM($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
-    my $unknown = $exifTool->Options('Unknown');
-    my $verbose = $exifTool->Options('Verbose');
+    my $unknown = $et->Options('Unknown');
+    my $verbose = $et->Options('Verbose');
     my ($hdr, $buff, $implicit, $vr, $len);
 #
@@ -3543,5 +3585,5 @@
         # file meta information transfer syntax is explicit little endian
         SetByteOrder('II');
-        $exifTool->SetFileType('DICOM');
+        $et->SetFileType('DICOM');
     } else {
         # test for a RAW DCM image (ACR-NEMA format, ie. no header)
@@ -3573,5 +3615,5 @@
         }
         $raf->Seek(0, 0) or return 0;   # rewind to start of file
-        $exifTool->SetFileType('ACR');
+        $et->SetFileType('ACR');
     }
 #
@@ -3595,5 +3637,5 @@
             # 1.2.840.10008.1.2.1.99 = deflated
             unless ($transferSyntax =~ /^1\.2\.840\.10008\.1\.2(\.\d+)?(\.\d+)?/) {
-                $exifTool->Warn("Unrecognized transfer syntax $transferSyntax");
+                $et->Warn("Unrecognized transfer syntax $transferSyntax");
                 last;
             }
@@ -3605,5 +3647,5 @@
             } elsif ($1 eq '.1' and $2 and $2 eq '.99') {
                 # inflate compressed data stream
-                if (eval 'require Compress::Zlib') {
+                if (eval { require Compress::Zlib }) {
                     # must use undocumented zlib feature to disable zlib header information
                     # because DICOM deflated data doesn't have the zlib header (ref 3)
@@ -3621,5 +3663,5 @@
                                 last if $stat == Compress::Zlib::Z_STREAM_END();
                             } else {
-                                $exifTool->Warn('Error inflating compressed data stream');
+                                $et->Warn('Error inflating compressed data stream');
                                 return 1;
                             }
@@ -3632,9 +3674,9 @@
                         $group = Get16u(\$buff, 0);
                     } else {
-                        $exifTool->Warn('Error initializing inflation');
+                        $et->Warn('Error initializing inflation');
                         return 1;
                     }
                 } else {
-                    $exifTool->Warn('Install Compress::Zlib to decode compressed data stream');
+                    $et->Warn('Install Compress::Zlib to decode compressed data stream');
                     return 1;
                 }
@@ -3667,6 +3709,6 @@
             if ($verbose) {
                 # start list of items in verbose output
-                $exifTool->VPrint(0, "$exifTool->{INDENT}+ [List of items]\n");
-                $exifTool->{INDENT} .= '| ';
+                $et->VPrint(0, "$$et{INDENT}+ [List of items]\n");
+                $$et{INDENT} .= '| ';
             }
         }
@@ -3707,5 +3749,5 @@
                 }
                 $$tagInfo{Unknown} = 1;
-                Image::ExifTool::AddTagToTable($tagTablePtr, $tag, $tagInfo);
+                AddTagToTable($tagTablePtr, $tag, $tagInfo);
             }
         }
@@ -3718,9 +3760,12 @@
         my $val;
         my $format = $dicomFormat{$vr};
+        # remove trailing space used to pad to an even number of characters
+        $buff =~ s/ $// unless $format or length($buff) & 0x01;
         if ($len > 1024) {
             # treat large data elements as binary data
             my $binData;
-            if ($exifTool->Options('Binary') or ($tagInfo and
-                $exifTool->{REQ_TAG_LOOKUP}->{lc($$tagInfo{Name})}))
+            my $lcTag = $tagInfo ? lc($$tagInfo{Name}) : 'unknown';
+            if ($$et{REQ_TAG_LOOKUP}{$lcTag} or
+                ($$et{OPTIONS}{Binary} and not $$et{EXCL_TAG_LOOKUP}{$lcTag}))
             {
                 $binData = $buff;   # must make a copy
@@ -3736,11 +3781,11 @@
             if ($vr eq 'DA') {
                 # format date values
-                $val =~ s/^(\d{4})(\d{2})(\d{2})/$1:$2:$3/;
+                $val =~ s/^ *(\d{4})(\d{2})(\d{2})/$1:$2:$3/;
             } elsif ($vr eq 'TM') {
                 # format time values
-                $val =~ s/^(\d{2})(\d{2})(\d{2}.*)/$1:$2:$3/;
+                $val =~ s/^ *(\d{2})(\d{2})(\d{2}[^ ]*)/$1:$2:$3/;
             } elsif ($vr eq 'DT') {
                 # format date/time values
-                $val =~ s/^(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2}.*)/$1:$2:$3 $4:$5:$6/;
+                $val =~ s/^ *(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2}[^ ]*)/$1:$2:$3 $4:$5:$6/;
             } elsif ($vr eq 'AT' and $len == 4) {
                 # convert attribute tag ID to hex format
@@ -3749,6 +3794,11 @@
             } elsif ($vr eq 'UI') {
                 # add PrintConv to translate registered UID's
-                $val =~ s/\0.*//; # truncate at null
+                $val =~ s/\0.*//s; # truncate at null
                 $$tagInfo{PrintConv} = \%uid if $uid{$val} and $tagInfo;
+            } elsif ($vr =~ /^(AE|CS|DS|IS|LO|PN|SH)$/) {
+                $val =~ s/ +$//;    # leading/trailing spaces not significant
+                $val =~ s/^ +//;
+            } elsif ($vr =~ /^(LT|ST|UT)$/) {
+                $val =~ s/ +$//;    # trailing spaces not significant
             }
         }
@@ -3760,5 +3810,5 @@
 
         # handle the new tag information
-        $exifTool->HandleTag($tagTablePtr, $tag, $val,
+        $et->HandleTag($tagTablePtr, $tag, $val,
             DataPt => \$buff,
             DataPos => $pos - $len,
@@ -3770,7 +3820,7 @@
 
         # stop indenting for list if we reached EndOfItems tag
-        $exifTool->{INDENT} =~ s/..$// if $verbose and $tag eq 'FFFE,E00D';
+        $$et{INDENT} =~ s/..$// if $verbose and $tag eq 'FFFE,E00D';
     }
-    $err and $exifTool->Warn('Error reading DICOM file (corrupted?)');
+    $err and $et->Warn('Error reading DICOM file (corrupted?)');
     return 1;
 }
@@ -3804,5 +3854,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/DJI.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/DJI.pm	(revision 34921)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/DJI.pm	(revision 34921)
@@ -0,0 +1,164 @@
+#------------------------------------------------------------------------------
+# File:         DJI.pm
+#
+# Description:  DJI Phantom maker notes tags
+#
+# Revisions:    2016-07-25 - P. Harvey Created
+#               2017-06-23 - PH Added XMP tags
+#------------------------------------------------------------------------------
+
+package Image::ExifTool::DJI;
+
+use strict;
+use vars qw($VERSION);
+use Image::ExifTool::Exif;
+use Image::ExifTool::XMP;
+use Image::ExifTool::GPS;
+
+$VERSION = '1.03';
+
+my %convFloat2 = (
+    PrintConv => 'sprintf("%+.2f", $val)',
+    PrintConvInv => '$val',
+);
+
+# DJI maker notes (ref PH, mostly educated guesses based on DJI QuickTime::UserData tags)
+%Image::ExifTool::DJI::Main = (
+    WRITE_PROC => \&Image::ExifTool::Exif::WriteExif,
+    CHECK_PROC => \&Image::ExifTool::Exif::CheckExif,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => q{
+        This table lists tags found in the maker notes of images from some DJI
+        Phantom drones.
+    },
+    0x01 => { Name => 'Make',       Writable => 'string' },
+  # 0x02 - int8u[4]: "1 0 0 0", "1 1 0 0"
+    0x03 => { Name => 'SpeedX',     Writable => 'float', %convFloat2 }, # (guess)
+    0x04 => { Name => 'SpeedY',     Writable => 'float', %convFloat2 }, # (guess)
+    0x05 => { Name => 'SpeedZ',     Writable => 'float', %convFloat2 }, # (guess)
+    0x06 => { Name => 'Pitch',      Writable => 'float', %convFloat2 },
+    0x07 => { Name => 'Yaw',        Writable => 'float', %convFloat2 },
+    0x08 => { Name => 'Roll',       Writable => 'float', %convFloat2 },
+    0x09 => { Name => 'CameraPitch',Writable => 'float', %convFloat2 },
+    0x0a => { Name => 'CameraYaw',  Writable => 'float', %convFloat2 },
+    0x0b => { Name => 'CameraRoll', Writable => 'float', %convFloat2 },
+);
+
+# thermal parameters in APP4 of DJI ZH20T images (ref forum11401)
+%Image::ExifTool::DJI::ThermalParams = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'APP4', 2 => 'Image' },
+    NOTES => 'Thermal parameters extracted from APP4 of DJI RJPEG files from the ZH20T.',
+  # 0x00 - 0xaa551206 - temperature header magic number 
+    0x24 => { Name => 'K1', Format => 'float' },
+    0x28 => { Name => 'K2', Format => 'float' },
+    0x2c => { Name => 'K3', Format => 'float' },
+    0x30 => { Name => 'K4', Format => 'float' },
+    0x34 => { Name => 'KF', Format => 'float' },
+    0x38 => { Name => 'B1', Format => 'float' },
+    0x3c => { Name => 'B2', Format => 'float' },
+    0x44 => { Name => 'ObjectDistance',     Format => 'int16u' },
+    0x46 => { Name => 'RelativeHumidity',   Format => 'int16u' },
+    0x48 => { Name => 'Emissivity',         Format => 'int16u' },
+    0x4a => { Name => 'Reflection',         Format => 'int16u',  },
+    0x4c => { Name => 'AmbientTemperature', Format => 'int16u' }, # (aka D1)
+    0x50 => { Name => 'D2', Format => 'int32s' },
+    0x54 => { Name => 'KJ', Format => 'int16u' },
+    0x56 => { Name => 'DB', Format => 'int16u' },
+    0x58 => { Name => 'KK', Format => 'int16u' },
+  # 0x500 - 0x55aa1206 - device header magic number 
+    # (nothing yet decoded from device header)
+);
+
+%Image::ExifTool::DJI::XMP = (
+    %Image::ExifTool::XMP::xmpTableDefaults,
+    GROUPS => { 0 => 'XMP', 1 => 'XMP-drone-dji', 2 => 'Location' },
+    NAMESPACE => 'drone-dji',
+    TABLE_DESC => 'XMP DJI',
+    VARS => { NO_ID => 1 },
+    NOTES => 'XMP tags used by DJI for images from drones.',
+    AbsoluteAltitude  => { Writable => 'real' },
+    RelativeAltitude  => { Writable => 'real' },
+    GimbalRollDegree  => { Writable => 'real' },
+    GimbalYawDegree   => { Writable => 'real' },
+    GimbalPitchDegree => { Writable => 'real' },
+    FlightRollDegree  => { Writable => 'real' },
+    FlightYawDegree   => { Writable => 'real' },
+    FlightPitchDegree => { Writable => 'real' },
+    GpsLatitude => {
+        Name => 'GPSLatitude',
+        Writable => 'real',
+        Avoid => 1,
+        PrintConv    => 'Image::ExifTool::GPS::ToDMS($self, $val, 1, "N")',
+        PrintConvInv => 'Image::ExifTool::GPS::ToDegrees($val, 1)',
+    },
+    GpsLongtitude => { # (sic)
+        Name => 'GPSLongtitude',
+        Writable => 'real',
+        PrintConv    => 'Image::ExifTool::GPS::ToDMS($self, $val, 1, "E")',
+        PrintConvInv => 'Image::ExifTool::GPS::ToDegrees($val, 1)',
+    },
+    GpsLongitude => { #PH (NC)
+        Name => 'GPSLongitude',
+        Writable => 'real',
+        Avoid => 1,
+        PrintConv    => 'Image::ExifTool::GPS::ToDMS($self, $val, 1, "E")',
+        PrintConvInv => 'Image::ExifTool::GPS::ToDegrees($val, 1)',
+    },
+    FlightXSpeed  => { Writable => 'real' },
+    FlightYSpeed  => { Writable => 'real' },
+    FlightZSpeed  => { Writable => 'real' },
+    CamReverse    => { }, # integer?
+    GimbalReverse => { }, # integer?
+    SelfData      => { Groups => { 2 => 'Image' } },
+    CalibratedFocalLength    => { Writable => 'real', Groups => { 2 => 'Image' } },
+    CalibratedOpticalCenterX => { Writable => 'real', Groups => { 2 => 'Image' } },
+    CalibratedOpticalCenterY => { Writable => 'real', Groups => { 2 => 'Image' } },
+    RtkFlag       => { }, # integer?
+    RtkStdLon     => { Writable => 'real' },
+    RtkStdLat     => { Writable => 'real' },
+    RtkStdHgt     => { Writable => 'real' },
+    DewarpData    => { Groups => { 2 => 'Image' } },
+    DewarpFlag    => { Groups => { 2 => 'Image' } }, # integer?
+    Latitude => {
+        Name => 'Latitude',
+        Writable => 'real',
+        PrintConv    => 'Image::ExifTool::GPS::ToDMS($self, $val, 1, "N")',
+        PrintConvInv => 'Image::ExifTool::GPS::ToDegrees($val, 1)',
+    },
+    Longitude => {
+        Name => 'Longitude',
+        Writable => 'real',
+        PrintConv    => 'Image::ExifTool::GPS::ToDMS($self, $val, 1, "E")',
+        PrintConvInv => 'Image::ExifTool::GPS::ToDegrees($val, 1)',
+    },
+);
+
+__END__
+
+=head1 NAME
+
+Image::ExifTool::DJI - DJI Phantom maker notes tags
+
+=head1 SYNOPSIS
+
+This module is loaded automatically by Image::ExifTool when required.
+
+=head1 DESCRIPTION
+
+This module contains definitions required by Image::ExifTool to interpret
+the maker notes in images from some DJI Phantom drones.
+
+=head1 AUTHOR
+
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
+
+This library is free software; you can redistribute it and/or modify it
+under the same terms as Perl itself.
+
+=head1 SEE ALSO
+
+L<Image::ExifTool::TagNames/DJI Tags>,
+L<Image::ExifTool(3pm)|Image::ExifTool>
+
+=cut
